
#include "infrared.h"

//   
typedef enum
{
No_Action    = 0,
Shot         = 1,
Shot_Delayed = 2
} Action_Enum;

//    ,  
static Action_Enum Action = No_Action;


/****************************************************************************/
/*   TIMER2     -                    */
/*  455000  / 1  / 7   = 65000     */
/*  65000       = 32500       */
/****************************************************************************/
void IR_Pwm_Init (void)
{
	DDRB |= (1<<PB3);      //  = 
	PORTB |= (0<<PB3);     //  = 0
	//    -    (CTC)
	//  1
	TCCR2 = (1<<WGM21)|(0<<WGM20)|(0<<CS22)|(0<<CS21)|(1<<CS20);
	//   7
	OCR2 = 6;
}


/********************/
/*       */
/********************/
void IR_Pwm_On (void)
{
	TCCR2 |= (0<<COM21)|(1<<COM20);  // Toggle OC2 on Compare Match
}


/*********************/
/*       */
/*********************/
void IR_Pwm_Off (void)
{
	TCCR2 &= ~((1<<COM21)|(1<<COM20));  // Normal port operation, OC2 disconnected
}


/****************************************/
/*    480  ( 33 )   */
/****************************************/
void IR_Filling (void)
{
	IR_Pwm_On();
	_delay_us(480);
	IR_Pwm_Off();
}


/******************************************/
/*    ""                      */
/*            */
/*         */
/******************************************/
void IR_Shot (void)
{
	Action = Shot;
}


/******************************************/
/*    "   2 "    */
/*            */
/*         */
/******************************************/
void IR_Shot_Delayed (void)
{
	Action = Shot_Delayed;
}


/********************************************************/
/*                         */
/*     ,      */
/*                                                      */
/*    ""                                    */
/*    480  ( 33 )                   */
/*    7324                                      */
/*    480  ( 33 )                   */
/*                                                      */
/*    "   2 "                  */
/*    480  ( 33 )                   */
/*    5371                                      */
/*    480  ( 33 )                   */
/********************************************************/
void IR_Process (void)
{
	if (Action == Shot)
	{
		IR_Filling();
		_delay_us(7324);
		IR_Filling();
	}
	if (Action == Shot_Delayed)
	{
		IR_Filling();
		_delay_us(5371);
		IR_Filling();
	}
	Action = No_Action;
}

