
#include "sleeep.h"

//       
static u16 Timer=0;


/**************************************/
/*                  */
/*        */
/**************************************/
void Sleep_Init (void)
{
	//     ,         
	DDRB |= (1<<PB5)|(1<<PB4)|(1<<PB2)|(1<<PB1)|(1<<PB0);
	DDRC |= (1<<PC5)|(1<<PC4)|(1<<PC3)|(1<<PC2)|(1<<PC1)|(1<<PC0);
	DDRD |= (1<<PD7)|(1<<PD6)|(1<<PD5)|(1<<PD4)|(1<<PD1)|(1<<PD0);
	//    - Power Down
	MCUCR |= (0<<SM2)|(1<<SM1)|(0<<SM0);
	//   
	asm volatile ("sei");
}


/***********************************************************************/
/*                         */
/*               */
/***********************************************************************/
void Sleep_Reset (void)
{
	Timer=0;
}


/*******************************************************************/
/*               */
/*******************************************************************/
void Sleep_Process (void)
{
	if (Timer++ >= CALC_TICKS(SLEEP_INTERVAL))  //  
	{
		Timer=0;
		//       
		GICR |= (1<<INT1)|(1<<INT0);
		//    
		MCUCR |= (1<<SE);
		//    
		asm volatile ("sleep");
		//   ,  
		GICR &= ~((1<<INT1)|(1<<INT0));
	}
}

